<?php

namespace STM\Club\Member;

use STM\StmFactory;

/**
 * Test class for ClubMemberValidator.
 * Generated by PHPUnit on 2012-03-29 at 20:52:11.
 * @group team_club
 */
class ClubMemberValidatorTest extends \PHPUnit_Framework_TestCase {

    private $club;
    private $club_members;

    protected function setUp() {
        $this->club = StmFactory::find()->Club->findById(1);
        $this->club_members = $this->club ? StmFactory::find()->ClubMember->findByClub($this->club) : array();
        ClubMemberValidator::init();
    }

    public function testCheck_create() {
        // existing club members
        foreach ($this->club_members as $member) {
            $club = StmFactory::find()->Club->findById($member->getIdClub());
            $person = StmFactory::find()->Person->findById($member->getIdPerson());
            $position = StmFactory::find()->PersonPosition->findById($member->getIdPosition());
            $this->assert_bad_arguments('checkCreate', array('club' => $club, 'position' => $position, 'person' => $person));
            // valid with different club if member not already exists
            foreach (StmFactory::find()->Club->findAll() as $club) {
                if (!StmFactory::find()->ClubMember->findById($club, $person, $position)) {
                    parent::assertTrue(ClubMemberValidator::checkCreate(array('club' => $club, 'position' => $position, 'person' => $person)));
                }
            }
        }
        // invalid values
        $club = StmFactory::find()->Club->findById(1);
        $person = StmFactory::find()->Person->findById(1);
        $position = StmFactory::find()->PersonPosition->findById(1);
        $this->assert_bad_arguments('checkCreate', null);
        $this->assert_bad_arguments('checkCreate', array('club' => $club, 'position' => $position, 'person' => null));
        $this->assert_bad_arguments('checkCreate', array('club' => $club, 'position' => null, 'person' => null));
        $this->assert_bad_arguments('checkCreate', array('club' => null, 'position' => $position, 'person' => $person));
        if (!$club || !$person || !$position) {
            $this->assert_bad_arguments('checkCreate', array('club' => $club, 'position' => $position, 'person' => $person));
        }
    }

    public function testCheck_position() {
        $all_positions = StmFactory::find()->PersonPosition->findAll();
        foreach ($this->club_members as $member) {
            ClubMemberValidator::setClubMember($member);            
            $person = StmFactory::find()->Person->findById($member->getIdPerson());
            foreach ($all_positions as $position) {                
                if (!StmFactory::find()->ClubMember->findById($this->club, $person, $position)) {
                    parent::assertTrue(ClubMemberValidator::checkPosition($position));
                }
            }
            $this->assert_bad_arguments('checkPosition', null);
            $this->assert_bad_arguments('checkPosition', array());
            $this->assert_bad_arguments('checkPosition', StmFactory::find()->PersonPosition->findById($member->getIdPosition()));
            ClubMemberValidator::resetClubMember();
        }
    }

    private function assert_bad_arguments($method, $data) {
        ClubMemberValidator::init();
        parent::assertFalse(ClubMemberValidator::$method($data));
        ClubMemberValidator::init();
    }

}

?>